#ifndef HD_ETH_H
#define HD_ETH_H

#include "stdint.h"

#define DP83848_PHY_ADDRESS   0x1

#define ETH_INIT_FLAG           0x01 /* Ethernet Init Flag */
#define ETH_LINK_FLAG           0x10 /* Ethernet Link Flag */

//IP ADDR
#define IP_ADDR0   192
#define IP_ADDR1   168
#define IP_ADDR2   0
#define IP_ADDR3   48

//MAC ADDR
#define MAC_ADDR0   2
#define MAC_ADDR1   8
#define MAC_ADDR2   4
#define MAC_ADDR3   2
#define MAC_ADDR4   0
#define MAC_ADDR5   0

/*NETMASK*/
#define NETMASK_ADDR0   255
#define NETMASK_ADDR1   255
#define NETMASK_ADDR2   255
#define NETMASK_ADDR3   0

/*Gateway Address*/
#define GW_ADDR0   192
#define GW_ADDR1   168
#define GW_ADDR2   0
#define GW_ADDR3   1


extern uint8_t eth_recFlag;

void LwIP_Pkt_Handle(void);

void ETH_BSP_Config(void);
uint8_t hd_ethGetPhyStatus(void);
void lwIP_Init(void);
#endif 




