#ifndef __LED_H
#define	__LED_H
#include "stm32f2xx.h"
//Ŷ
/*******************************************************/

#define LED_PIN                  GPIO_Pin_6                 
#define LED_GPIO_PORT            GPIOF                      
#define LED_GPIO_CLK             RCC_AHB1Periph_GPIOF

#define NET_STATUS_LED_PIN                  GPIO_Pin_8                
#define NET_STATUS_LED_GPIO_PORT            GPIOF                      
#define NET_STATUS_LED_GPIO_CLK             RCC_AHB1Periph_GPIOF

#define STATUS_LED_PIN                  GPIO_Pin_7                 
#define STATUS_LED_GPIO_PORT            GPIOF                      
#define STATUS_LED_GPIO_CLK             RCC_AHB1Periph_GPIOF

/************************************************************/


/** LEDĺ꣬
	* LED͵ƽON=0OFF=1
	* LEDߵƽѺóON=1 OFF=0 
	*/
#define ON  1
#define OFF 0

/* κ꣬һʹ */
#define LED(a)	if (a)	\
					GPIO_SetBits(LED_GPIO_PORT,LED_PIN);\
					else		\
					GPIO_ResetBits(LED_GPIO_PORT,LED_PIN)
#define NET_STATUS_LED(a)	if (a)	\
					GPIO_SetBits(NET_STATUS_LED_GPIO_PORT,NET_STATUS_LED_PIN);\
					else		\
					GPIO_ResetBits(NET_STATUS_LED_GPIO_PORT,NET_STATUS_LED_PIN)
					
#define STATUS_LED(a)	if (a)	\
					GPIO_SetBits(STATUS_LED_GPIO_PORT,STATUS_LED_PIN);\
					else		\
					GPIO_ResetBits(STATUS_LED_GPIO_PORT,STATUS_LED_PIN)


void LED_GPIO_Config(void);
void NET_STATUS_LED_Config(void);
void STATUS_LED_Config(void);
					
int hd_netledOpen(void);					
int hd_netledClose(void);					
void hd_netledSetOpenTime(int tms);
					
#endif

