#include "protocol.h"
#include "stdint.h"
#include "stdlib.h"
#include "string.h"
#include "node_message.h"
#include "sys_mqtt.h"
/*****************************protocolҪΪӽڵͨѶЭʹ**********************************/
/*****************************Ҫظӽڵѯݵı**********************************/
/*****************************ӽڵط͵              **********************************/
/*****************************ӽڵӦӦӦ                     **********************************/
/*****************************ӽڵӦӦӦĽ               **********************************/

static volatile int deviceNum = 0;		// ¼ѯȡ豸Ľλ
static volatile int paramsNum = 0;		// ¼ѯȡԵĽλ
static volatile int startDeviceNum = 0; // ¼ѯȡ豸Ŀʼλ
static volatile int startParamsNum = 0; // ¼ѯȡ豸ԵĿʼλ
void insertHexData(uint8_t *String, const uint8_t *hexData, uint8_t insertIndex, uint8_t length);

enum
{
	protocol_dlt645_97 = 0x08,
	protocol_modbus_read,
	protocol_dlt645_07
} PROTOCOL_LENGTH; // ÿЭݰʼֲͬЭ
// öٲɼݵĴ洢
enum
{
	typeInt = 1,
	typeFloat,
	typeDouble
} DATAType;
// öMODBUSЭ幦
enum
{
	READ_COIL = 0x01,
	WRITE_COIL = 0x05,
	WRITE_COILS = 0x0F,
	READ_REGISTER = 0x03,
	WRITE_REFISTER = 0x06,
	WRITE_REGISTERS = 0x10
} MODBUS_COMMAND;
// С
typedef enum
{
	MModBus_16bitOrder_AB = 1, // 
	MModBus_16bitOrder_BA,
} MModBus_16bitOrder_t;
/*
*********************************************************************************************************
*	  : void masterSendNodeString(uint8_t nodeIndex)Index±0ʼ
*	˵: ȡصnodeIndexµ·ʽ,ע˴ûжnodeǷΪNULLжϣȷиýڵϢ
*	    ΣnodeIndexڼڵݡstringܳɵĴݵַsizeɵַС
*	  ֵ: 0:ýڵѾûҪȥˣ1:ýڵ»ӵԵȴ
	עһֻܴ20Եֵ䷶ΧҪɷ
	߼ÿεøúܳһstring,㹻ʱһ20Եָ¼豸λãλã´ٵôӽλٿʼܾɲ20Եstringˣʱʼ豸num,Զλ
				ҲҪ¼ÿοʼ豸λúλãӦźŵĽ
*********************************************************************************************************
*/

int masterSendNodeString(uint8_t nodeIndex, uint8_t *string, uint16_t *size)
{
	startDeviceNum = deviceNum; // ʼλõϴνλ
	startParamsNum = paramsNum; // ʼλõϴνλ
	int nowDeviceNum = deviceNum;
	int nowparamsNum = paramsNum;
	GATEWAY_PARAMS *gateway;
	gateway = get_gateway_config_params();


	// ҵǰ豸λ
	DEVICE_PARAMS *currentDevice = gateway->device_params;
	while (nowDeviceNum)
	{
		currentDevice = currentDevice->nextDevice;
		nowDeviceNum--;
	}

	// ƶλõλԵһλ
	GATEWAY_READ_MODBUS_COMMAND *currentModbusParams = currentDevice->params->gateway_read_modbus_command;
	GATEWAY_READ_DLT645_COMMAND *currentDlt645Params = currentDevice->params->gateway_read_dlt645_command;
	switch (currentDevice->protocol)
	{
	case MODBUS:
		while (nowparamsNum)
		{
			currentModbusParams = currentModbusParams->nextParams;
			nowparamsNum--;
		}
		break;
	case DLT645_07:
	case DLT645_97:

		while (nowparamsNum)
		{
			currentDlt645Params = currentDlt645Params->nextParams;
			nowparamsNum--;
		}
		break;
	default:
		break;
	}

	// 20ѭ·
	int i = 0;
	int len;
	len = strlen((char*)string);
	do
	{
		switch (currentDevice->protocol)
		{
		case MODBUS_READ:
		{
			uint8_t protocolHexData = protocol_modbus_read;
			insertHexData(string, &protocolHexData, len, 1); // modbus
			len++;
			insertHexData(string, &currentModbusParams->functionCode, len, 1); // ȡ
			len++;
			insertHexData(string, &currentDevice->MDBdataType, len, 1); // ȡݸʽ
			len++;
			insertHexData(string, &currentModbusParams->slaveAddress, len, 1); // modbusվַ
			len++;
			insertHexData(string, (uint8_t *)&currentModbusParams->registerAddress, len, 2); // modbusĴַ
			len += 2;
			insertHexData(string, &currentModbusParams->decimalPoint, len, 1); // Сλ
			len++;
			insertHexData(string, &currentDevice->MDBbigLittleFormat, len, 1); // С
			len++;
			// Զȡϣλһ
			i++;
			currentModbusParams = currentModbusParams->nextParams;
			if (currentModbusParams == NULL)
			{
				currentDevice = currentDevice->nextDevice;
				if (currentModbusParams == NULL)
				{
					deviceNum = 0; // λȫ0
					paramsNum = 0;
					*size = len;
					return 1;
				}
				currentModbusParams = currentDevice->params->gateway_read_modbus_command;
				nowDeviceNum++;
				nowparamsNum = 0;
			}
			break;
		}

		case DLT645_07:
		{
			uint8_t protocolHexData = protocol_dlt645_07;
			insertHexData(string, &protocolHexData, len, 1); // dlt645_07ݳ
			len++;
			insertHexData(string, (uint8_t *)&currentDlt645Params->deviceID645, len, 6); // dlt645ַ
			len += 6;
			insertHexData(string, (uint8_t *)&currentDlt645Params->Identification, len, 4);
			len += 4;
			// Զȡϣλһ
			i++;
			currentDlt645Params = currentDlt645Params->nextParams;
			if (currentDlt645Params == NULL)
			{
				currentDevice = currentDevice->nextDevice;
				if (currentDevice == NULL)
				{
					deviceNum = 0; // λȫ0
					paramsNum = 0;
					*size = len;
					return 1;
				}
				currentDlt645Params = currentDevice->params->gateway_read_dlt645_command;
				nowDeviceNum++;
				nowparamsNum = 0;
			}
			break;
		}
		case DLT645_97:
		{
			uint8_t protocolHexData = protocol_dlt645_97;
			insertHexData(string, &protocolHexData, len, 1); // dlt645_97ݳ
			len++;
			insertHexData(string, (uint8_t *)&currentDlt645Params->deviceID645, len, 6); // dlt645_97ַ
			len += 6;
			insertHexData(string, (uint8_t *)&currentDlt645Params->Identification, len, 4); // dlt645_97ݱʶ
			len += 4;

			// Զȡϣλһ
			i++;
			currentDlt645Params = currentDlt645Params->nextParams;
			if (currentDlt645Params == NULL)
			{
				currentDevice = currentDevice->nextDevice;
				currentDlt645Params = currentDevice->params->gateway_read_dlt645_command;
				if (currentDlt645Params == NULL)
				{
					deviceNum = 0; // λȫ0
					paramsNum = 0;
					*size = len;
					return 1;
				}
				currentDlt645Params = currentDevice->params->gateway_read_dlt645_command; // λ
				nowDeviceNum++;
				nowparamsNum = 0;
			}
			break;
		}
		
		default:
			goto end_while;
		}
		nowparamsNum++;
	} while (i != 20);
end_while:
	// ½λ÷Ϊһֻڵǰ豸ѯʱnowDeviceNumûиı,һ豸ڵ
	if (nowDeviceNum == 0)
	{
		deviceNum = startDeviceNum;
		paramsNum = startParamsNum + nowparamsNum;
	}
	else
	{
		deviceNum = startDeviceNum + nowDeviceNum;
		paramsNum = nowparamsNum - 1;
	}
	*size = len;
	return 0;
}
/*
*********************************************************************************************************
*	  : void insertHexData(uint8_t *originalString,const uint8_t *hexData,int position)
*	    Σuint8_t *StringҪַhexDatahexݣinsertIndex±λãlengthݳ
*	  ֵ: 
  עԱַܰ0x00Ҫʹstrlen
*********************************************************************************************************
*/
void insertHexData(uint8_t *String, const uint8_t *hexData, uint8_t insertIndex, uint8_t length)
{
	memcpy(String + insertIndex, hexData, length);
}

/*
*********************************************************************************************************
*	  : uint8_t SlaveProtocolAnalysis(uint8_t *buff,uint16_t len)
*	    Σuint8_t *buffȴַݣ
*	  ֵ: 0:ǸýڵϢûнκδ1:ΪýڵϢյҪеӦл
	ʱҪжǷΪýڵϢstuct B *p=malloc(sizeof(struct B);
*********************************************************************************************************
*/

uint16_t LocalAddress=0x1F6E;
uint8_t SlaveProtocolAnalysis(uint8_t *buff, uint16_t len)
{

	NODE_DEVICE_PARAMS *node_receive_params;
	free_all_node_params();
	node_receive_params = get_node_receive_params();
	uint16_t slaveAdress = buff[0] << 8 | buff[1];
	int protocol_location = 2; // ʼЭλ
	uint8_t i = 0;
	while (1)
	{
		if (slaveAdress == LocalAddress) // жϴϢǷΪýڵϢ
		{		
			switch (buff[protocol_location]) // ȡյʲôЭ
			{
			case protocol_modbus_read:
				protocol_location++;
				node_receive_params->params[i].protcol = MODBUS_READ;
				node_receive_params->params[i].dlt645_params = NULL;
				node_receive_params->params[i].modbus_read = malloc(sizeof(NODE_MODBUS_READ));
				node_receive_params->params[i].modbus_write = NULL;
				node_receive_params->params[i].modbus_read->functionCode = buff[protocol_location + 1];										   // functionCode
				node_receive_params->params[i].modbus_read->dataType = buff[protocol_location + 2];											   // ݸʽ
				node_receive_params->params[i].modbus_read->slaveAddress = buff[protocol_location + 3];										   // վַ
				node_receive_params->params[i].modbus_read->registerAddress = buff[protocol_location + 5] << 8 || buff[protocol_location + 4]; // Ĵַ
				node_receive_params->params[i].modbus_read->registerLength = buff[protocol_location + 7] << 8 || buff[protocol_location + 6];  // ҪļĴ
				node_receive_params->params[i].modbus_read->precision = buff[protocol_location + 8];										   // С㾫
				node_receive_params->params[i].modbus_read->bigLittleFormat = buff[protocol_location + 9];									   // ݴС˸ʽ
				protocol_location += protocol_modbus_read;
				break;
			case protocol_dlt645_07:
				protocol_location++;
				node_receive_params->params[i].protcol = DLT645_07;
				node_receive_params->params[i].dlt645_params = malloc(sizeof(NODE_DLT645_PARAMS));
				node_receive_params->params[i].modbus_read = NULL;
				node_receive_params->params[i].modbus_write = NULL;
				memcpy(node_receive_params->params[i].dlt645_params->deviceType645, buff + protocol_location, 6);
				memcpy((uint8_t *)&node_receive_params->params[i].dlt645_params->dataType645, buff + protocol_location + 6, 4);
				protocol_location += protocol_dlt645_07;
				break;
			case protocol_dlt645_97:
				protocol_location++;
				node_receive_params->params[i].protcol = DLT645_97;
				node_receive_params->params[i].dlt645_params = malloc(sizeof(NODE_DLT645_PARAMS));
				node_receive_params->params[i].modbus_read = NULL;
				node_receive_params->params[i].modbus_write = NULL;
				memcpy(node_receive_params->params[i].dlt645_params->deviceType645, buff + protocol_location, 6);
				memcpy((uint8_t *)&node_receive_params->params[i].dlt645_params->dataType645, buff + protocol_location + 6, 2);
				protocol_location += protocol_dlt645_97;
				break;
			default: // û20
				return 1;
			}
		}
		else
		{
			node_receive_params->Index = i; // ¼жݴ
			return 0;
		}
		i++;
		if (protocol_location > len) // жݽǷԽ,Խת
		{
			return 1;
		}
	}
}
/*
*********************************************************************************************************
*	  : nodeSendReadValue(uint8_t *string)
*	    ΣnodeشݣΪ
*	  ֵ: 
*********************************************************************************************************
*/

void nodeSendReaddValue(uint8_t *string,uint16_t *size)
{
	NODE_DEVICE_PARAMS *node_receive_params;
	node_receive_params = get_node_receive_params();
	int i = 0;
	int len=0;
	//ȼnodeĵַnodeַʱд
	string[len]= LocalAddress>>8;
	string[len+1]=LocalAddress;
	len+=2;
	
	while (i != 20)
	{
		switch (node_receive_params->params[i].protcol)
		{
		case DLT645_07:
		case DLT645_97:
			if (node_receive_params->params[i].dlt645_params->rxLen <= 4)
			{
				string[len] = 0x04;
				len++;
				memcpy(&string[len], node_receive_params->params[i].dlt645_params->value, 4);
				len += 4;
			}
			else if (node_receive_params->params[i].dlt645_params->rxLen == 5)
			{
				string[len] = 0x05;
				len++;
				memcpy(&string[len], node_receive_params->params[i].dlt645_params->value, 5);
				len += 5;
			}
			else if (node_receive_params->params[i].dlt645_params->rxLen == 9)
			{
				string[len] = 0x09;
				len++;
				memcpy(&string[len], node_receive_params->params[i].dlt645_params->value, 9);
				len += 9;
			}
			else
			{
				string[len] = 0x00;
				len++;
			}
			break;
		case MODBUS:
			if (node_receive_params->params[i].modbus_read->rxLen == 4)
			{
				string[len] = 0x04;
				len++;
				memcpy(&string[len], node_receive_params->params[i].dlt645_params->value, 4);
				len += 4;
			}
			else
			{
				string[len] = 0x00;
				len++;
			}
			break;
		default:
			*size=len;
			return;
		}
		i++;
	}
	*size=len;
}
/*
*********************************************************************************************************
*	  : GatewayProtocolAnalysis(uint8_t *string)
*	    ΣڵӦϢνΪjson
*	  ֵ: 0δjsonݣ1json
*********************************************************************************************************
*/

int GatewayProtocolAnalysis(uint8_t *string, uint16_t len)
{
	// ȡϴѭֹͣλ
	int nowDeviceNum = startDeviceNum;
	int nowparamsNum = startParamsNum;
	GATEWAY_PARAMS *gateway;
	gateway = get_gateway_config_params();
	// ҵýڵѯ
	DEVICE_PARAMS *currentDevice = gateway->device_params;
	while (nowDeviceNum)
	{
		currentDevice = currentDevice->nextDevice;
		nowDeviceNum--;
	}
	// ƶλõʼ
	GATEWAY_READ_MODBUS_COMMAND *currentModbusParams = currentDevice->params->gateway_read_modbus_command;
	GATEWAY_READ_DLT645_COMMAND *currentDlt645Params = currentDevice->params->gateway_read_dlt645_command;
	switch (currentDevice->protocol)
	{
	case MODBUS:
		while (nowparamsNum)
		{
			currentModbusParams = currentModbusParams->nextParams;
			nowparamsNum--;
		}
		break;
	case DLT645_07:
	case DLT645_97:

		while (nowparamsNum)
		{
			currentDlt645Params = currentDlt645Params->nextParams;
			nowparamsNum--;
		}
		break;
	default:
		break;
	}
	memset(pubJsonString,0,jsonMaxSize);
	
	sprintf(pubJsonString, "{\"data\":[");
	int index = 2; // ӽڵַ
	while (index <len)
	{
		switch (currentDevice->protocol)
		{
		case MODBUS:
			// modbusЭ
			switch (*(string + index))
			{
			case 0x00:
				// û
				index++;
				break;
			case 0x04:
				if (currentDevice->MDBdataType == 0x01 && currentModbusParams->decimalPoint == 0x00) // modbusײ洢 1INT 2float
				{
					uint32_t data;
					data = string[index + 1] + (string[index + 2] >> 8) + (string[index + 3] >> 16) + (string[index + 4] >> 24);
					sprintf(pubJsonString + strlen(pubJsonString), "{\"deviceId\":\"%s\",\"%s\":%d},", currentDevice->deviceID, currentModbusParams->keyword, data);
				}
				else // intС㣬ߵײfloatfloat
				{
					float value;
					memcpy(&value,string+index+1,4);
					sprintf(pubJsonString + strlen(pubJsonString), "{\"deviceId\":\"%s\",\"%s\":%.2f},", currentDevice->deviceID,currentModbusParams->keyword,value);
				}
				index += 4;
				break;
			default:
				break;
			}
			currentModbusParams = currentModbusParams->nextParams;
			if (currentModbusParams == NULL)
			{
				currentDevice = currentDevice->nextDevice;
				if(currentDevice->protocol==MODBUS)
				{
					currentModbusParams=currentModbusParams->nextParams;
				}
				else
				{
					currentDlt645Params=currentDlt645Params->nextParams;
				}
			}
			break;

		case DLT645_07:
		case DLT645_97:
			switch (*(string + index))
			{
			case 0x00:
			index++;
			break;
			case 0x04:
			{
				index++;
				float value;
				memcpy(&value,string+index,sizeof(float));
				sprintf(pubJsonString + strlen(pubJsonString), "{\"deviceId\":\"%s\",\"%s\": %.2f},", currentDevice->deviceID, currentDlt645Params->keyword,value);
				index += 4;
			}
			break;
			case 0x05:
			{
				index++;
				//%02Ϊʱ
				sprintf(pubJsonString + strlen(pubJsonString), "{\"deviceId\":\"%s\",\"%s\": \"%02X%02X%02X%02X%02X\"},",
						currentDevice->deviceID, currentDlt645Params->keyword, string[index + 4], string[index + 3], string[index + 2], string[index + 1], string[index]);
				index += 5;
			}
			break;
			case 9:
			{
				index++;
				float value;
				memcpy(&value, &string[index], 4);
				sprintf(pubJsonString + strlen(pubJsonString), "{\"deviceId\":\"%s\",\"%s\":\"%02X%02X%02X%02X%02X%.2f\"},",
						currentDevice->deviceID, currentDlt645Params->keyword, string[index + 8], string[index + 7], string[index + 6], string[index + 5], string[index + 4], value);
				index+=9;
			}
			break;
			default:
				break;
			}
			//ƶ¸
			switch (currentDevice->protocol)
			{
				case DLT645_97:
				case DLT645_07:
					currentDlt645Params = currentDlt645Params->nextParams;
						if (currentDlt645Params == NULL)
						{
							currentDevice = currentDevice->nextDevice;
							currentDlt645Params=currentDevice->params->gateway_read_dlt645_command;
						}
					break;
				case MODBUS:
					currentModbusParams=currentModbusParams->nextParams;
					if(currentModbusParams==NULL)
					{
						currentDevice=currentDevice->nextDevice;
						currentDlt645Params=currentDevice->params->gateway_read_dlt645_command;
					}
					break;
			}
			break;
		default:
			break;
		}
	}
	if(strlen(pubJsonString)<10)
	{
		return 0;
	}
	sprintf(pubJsonString+strlen(pubJsonString)-1,"]}");
	//װjsonݿʼmqtt䷢ɱʶ
	int msg = MBOX_USER_PUBLISHQOS2;	
	if(mqtt_connectFlag==1) OSMboxPost(mqtt_sendMseeageMbox, &msg);
	return 1;
}
